Index: sansdataloader/docs/sphinx/_build/html/genindex.html
===================================================================
--- sansdataloader/docs/sphinx/_build/html/genindex.html	(revision 16771b0d2f26b851bcb5472537c6fc741a686b66)
+++ sansdataloader/docs/sphinx/_build/html/genindex.html	(revision 16771b0d2f26b851bcb5472537c6fc741a686b66)
@@ -0,0 +1,350 @@
+
+
+<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
+  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
+
+<html xmlns="http://www.w3.org/1999/xhtml">
+  <head>
+    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+    
+    <title>Index &mdash; DataLoader v0.1.0 documentation</title>
+    <link rel="stylesheet" href="_static/default.css" type="text/css" />
+    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
+    <script type="text/javascript">
+      var DOCUMENTATION_OPTIONS = {
+        URL_ROOT:    '',
+        VERSION:     '0.1.0',
+        COLLAPSE_INDEX: false,
+        FILE_SUFFIX: '.html',
+        HAS_SOURCE:  true
+      };
+    </script>
+    <script type="text/javascript" src="_static/jquery.js"></script>
+    <script type="text/javascript" src="_static/underscore.js"></script>
+    <script type="text/javascript" src="_static/doctools.js"></script>
+    <link rel="top" title="DataLoader v0.1.0 documentation" href="index.html" /> 
+  </head>
+  <body>
+    <div class="related">
+      <h3>Navigation</h3>
+      <ul>
+        <li class="right" style="margin-right: 10px">
+          <a href="#" title="General Index"
+             accesskey="I">index</a></li>
+        <li class="right" >
+          <a href="py-modindex.html" title="Python Module Index"
+             >modules</a> |</li>
+        <li><a href="index.html">DataLoader v0.1.0 documentation</a> &raquo;</li> 
+      </ul>
+    </div>  
+
+    <div class="document">
+      <div class="documentwrapper">
+        <div class="bodywrapper">
+          <div class="body">
+            
+
+   <h1 id="index">Index</h1>
+
+   <div class="genindex-jumpbox">
+   <a href="#A"><strong>A</strong></a> | <a href="#B"><strong>B</strong></a> | <a href="#C"><strong>C</strong></a> | <a href="#D"><strong>D</strong></a> | <a href="#E"><strong>E</strong></a> | <a href="#F"><strong>F</strong></a> | <a href="#G"><strong>G</strong></a> | <a href="#I"><strong>I</strong></a> | <a href="#L"><strong>L</strong></a> | <a href="#P"><strong>P</strong></a> | <a href="#R"><strong>R</strong></a> | <a href="#S"><strong>S</strong></a> | <a href="#V"><strong>V</strong></a> | <a href="#W"><strong>W</strong></a> | <a href="#X"><strong>X</strong></a> | <a href="#Y"><strong>Y</strong></a> | <a href="#Z"><strong>Z</strong></a> 
+   </div>
+<h2 id="A">A</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.add_notes">add_notes() (DataLoader.data_info.Data1D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.add_notes">(DataLoader.data_info.Data2D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.DataInfo.add_notes">(DataLoader.data_info.DataInfo method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Aperture">Aperture (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.append_empty_process">append_empty_process() (DataLoader.data_info.Data1D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.append_empty_process">(DataLoader.data_info.Data2D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.DataInfo.append_empty_process">(DataLoader.data_info.DataInfo method)</a></dt>
+  </dl></dd>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.associate_file_reader">associate_file_reader() (DataLoader.loader.Loader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/loader.html#DataLoader.loader.Registry.associate_file_reader">(DataLoader.loader.Registry method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.associate_file_type">associate_file_type() (DataLoader.loader.Loader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/loader.html#DataLoader.loader.Registry.associate_file_type">(DataLoader.loader.Registry method)</a></dt>
+  </dl></dd>
+</dl></td>
+</tr></table>
+
+<h2 id="B">B</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Boxavg">Boxavg (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Boxcut">Boxcut (class in DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Boxsum">Boxsum (class in DataLoader.manipulations)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="C">C</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/red2d_reader.html#DataLoader.readers.red2d_reader.check_point">check_point() (in module DataLoader.readers.red2d_reader)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.CircularAverage">CircularAverage (class in DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.clone_without_data">clone_without_data() (DataLoader.data_info.Data1D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.clone_without_data">(DataLoader.data_info.Data2D method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Collimation">Collimation (class in DataLoader.data_info)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="D">D</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D">Data1D (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data2D">Data2D (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.DataInfo">DataInfo (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/data_info.html#module-DataLoader.data_info">DataLoader.data_info (module)</a></dt>
+    <dt><a href="api/loader.html#module-DataLoader.loader">DataLoader.loader (module)</a></dt>
+    <dt><a href="api/manipulations.html#module-DataLoader.manipulations">DataLoader.manipulations (module)</a></dt>
+    <dt><a href="api/readers/abs_reader.html#module-DataLoader.readers.abs_reader">DataLoader.readers.abs_reader (module)</a></dt>
+    <dt><a href="api/readers/ascii_reader.html#module-DataLoader.readers.ascii_reader">DataLoader.readers.ascii_reader (module)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/associations.html#module-DataLoader.readers.associations">DataLoader.readers.associations (module)</a></dt>
+    <dt><a href="api/readers/cansas_reader.html#module-DataLoader.readers.cansas_reader">DataLoader.readers.cansas_reader (module)</a></dt>
+    <dt><a href="api/readers/danse_reader.html#module-DataLoader.readers.danse_reader">DataLoader.readers.danse_reader (module)</a></dt>
+    <dt><a href="api/readers/hfir1d_reader.html#module-DataLoader.readers.hfir1d_reader">DataLoader.readers.hfir1d_reader (module)</a></dt>
+    <dt><a href="api/readers/IgorReader.html#module-DataLoader.readers.IgorReader">DataLoader.readers.IgorReader (module)</a></dt>
+    <dt><a href="api/readers/red2d_reader.html#module-DataLoader.readers.red2d_reader">DataLoader.readers.red2d_reader (module)</a></dt>
+    <dt><a href="api/readers/tiff_reader.html#module-DataLoader.readers.tiff_reader">DataLoader.readers.tiff_reader (module)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Detector">Detector (class in DataLoader.data_info)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="E">E</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Registry.extensions">extensions() (DataLoader.loader.Registry method)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="F">F</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.find_plugins">find_plugins() (DataLoader.loader.Loader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/loader.html#DataLoader.loader.Registry.find_plugins">(DataLoader.loader.Registry method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.flip_phi">flip_phi() (in module DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Registry.formats">formats() (DataLoader.loader.Registry method)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="G">G</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.get_content">get_content() (in module DataLoader.readers.cansas_reader)</a></dt>
+    <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.get_float">get_float() (in module DataLoader.readers.cansas_reader)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.get_intercept">get_intercept() (in module DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.get_pixel_fraction">get_pixel_fraction() (in module DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.get_pixel_fraction_square">get_pixel_fraction_square() (in module DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.get_q">get_q() (in module DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.get_q_compo">get_q_compo() (in module DataLoader.manipulations)</a></dt>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.get_wildcards">get_wildcards() (DataLoader.loader.Loader method)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="I">I</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.is_slit_smeared">is_slit_smeared() (DataLoader.data_info.Data1D method)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="L">L</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.load">load() (DataLoader.loader.Loader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/loader.html#DataLoader.loader.Registry.load">(DataLoader.loader.Registry method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader">Loader (class in DataLoader.loader)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/loader.html#DataLoader.loader.Registry.lookup">lookup() (DataLoader.loader.Registry method)</a></dt>
+    <dt><a href="api/loader.html#DataLoader.loader.Registry.lookup_writers">lookup_writers() (DataLoader.loader.Registry method)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="P">P</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.plottable_1D">plottable_1D (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.plottable_2D">plottable_2D (class in DataLoader.data_info)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Process">Process (class in DataLoader.data_info)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="R">R</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/abs_reader.html#DataLoader.readers.abs_reader.Reader.read">read() (DataLoader.readers.abs_reader.Reader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/readers/IgorReader.html#DataLoader.readers.IgorReader.Reader.read">(DataLoader.readers.IgorReader.Reader method)</a></dt>
+      <dt><a href="api/readers/ascii_reader.html#DataLoader.readers.ascii_reader.Reader.read">(DataLoader.readers.ascii_reader.Reader method)</a></dt>
+      <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.Reader.read">(DataLoader.readers.cansas_reader.Reader method)</a></dt>
+      <dt><a href="api/readers/danse_reader.html#DataLoader.readers.danse_reader.Reader.read">(DataLoader.readers.danse_reader.Reader method)</a></dt>
+      <dt><a href="api/readers/hfir1d_reader.html#DataLoader.readers.hfir1d_reader.Reader.read">(DataLoader.readers.hfir1d_reader.Reader method)</a></dt>
+      <dt><a href="api/readers/red2d_reader.html#DataLoader.readers.red2d_reader.Reader.read">(DataLoader.readers.red2d_reader.Reader method)</a></dt>
+      <dt><a href="api/readers/tiff_reader.html#DataLoader.readers.tiff_reader.Reader.read">(DataLoader.readers.tiff_reader.Reader method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/readers/associations.html#DataLoader.readers.associations.read_associations">read_associations() (in module DataLoader.readers.associations)</a></dt>
+    <dt><a href="api/readers/abs_reader.html#DataLoader.readers.abs_reader.Reader">Reader (class in DataLoader.readers.abs_reader)</a></dt>
+    <dd><dl>
+      <dt><a href="api/readers/IgorReader.html#DataLoader.readers.IgorReader.Reader">(class in DataLoader.readers.IgorReader)</a></dt>
+      <dt><a href="api/readers/ascii_reader.html#DataLoader.readers.ascii_reader.Reader">(class in DataLoader.readers.ascii_reader)</a></dt>
+      <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.Reader">(class in DataLoader.readers.cansas_reader)</a></dt>
+      <dt><a href="api/readers/danse_reader.html#DataLoader.readers.danse_reader.Reader">(class in DataLoader.readers.danse_reader)</a></dt>
+      <dt><a href="api/readers/hfir1d_reader.html#DataLoader.readers.hfir1d_reader.Reader">(class in DataLoader.readers.hfir1d_reader)</a></dt>
+      <dt><a href="api/readers/red2d_reader.html#DataLoader.readers.red2d_reader.Reader">(class in DataLoader.readers.red2d_reader)</a></dt>
+      <dt><a href="api/readers/tiff_reader.html#DataLoader.readers.tiff_reader.Reader">(class in DataLoader.readers.tiff_reader)</a></dt>
+  </dl></dd>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.reader2D_converter">reader2D_converter() (in module DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/associations.html#DataLoader.readers.associations.register_readers">register_readers() (in module DataLoader.readers.associations)</a></dt>
+    <dt><a href="api/loader.html#DataLoader.loader.Registry">Registry (class in DataLoader.loader)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Ring">Ring (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Ringcut">Ringcut (class in DataLoader.manipulations)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="S">S</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Sample">Sample (class in DataLoader.data_info)</a></dt>
+    <dt><a href="api/loader.html#DataLoader.loader.Loader.save">save() (DataLoader.loader.Loader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/loader.html#DataLoader.loader.Registry.save">(DataLoader.loader.Registry method)</a></dt>
+  </dl></dd>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.Sectorcut">Sectorcut (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.SectorPhi">SectorPhi (class in DataLoader.manipulations)</a></dt>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.SectorQ">SectorQ (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.SlabX">SlabX (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/manipulations.html#DataLoader.manipulations.SlabY">SlabY (class in DataLoader.manipulations)</a></dt>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Source">Source (class in DataLoader.data_info)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="V">V</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Vector">Vector (class in DataLoader.data_info)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="W">W</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.Reader.write">write() (DataLoader.readers.cansas_reader.Reader method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/readers/red2d_reader.html#DataLoader.readers.red2d_reader.Reader.write">(DataLoader.readers.red2d_reader.Reader method)</a></dt>
+  </dl></dd>
+</dl></td>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/readers/cansas_reader.html#DataLoader.readers.cansas_reader.write_node">write_node() (in module DataLoader.readers.cansas_reader)</a></dt>
+</dl></td>
+</tr></table>
+
+<h2 id="X">X</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.xaxis">xaxis() (DataLoader.data_info.Data1D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.xaxis">(DataLoader.data_info.Data2D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.plottable_1D.xaxis">(DataLoader.data_info.plottable_1D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.plottable_2D.xaxis">(DataLoader.data_info.plottable_2D method)</a></dt>
+  </dl></dd>
+</dl></td>
+</tr></table>
+
+<h2 id="Y">Y</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data1D.yaxis">yaxis() (DataLoader.data_info.Data1D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.yaxis">(DataLoader.data_info.Data2D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.plottable_1D.yaxis">(DataLoader.data_info.plottable_1D method)</a></dt>
+      <dt><a href="api/data_info.html#DataLoader.data_info.plottable_2D.yaxis">(DataLoader.data_info.plottable_2D method)</a></dt>
+  </dl></dd>
+</dl></td>
+</tr></table>
+
+<h2 id="Z">Z</h2>
+<table style="width: 100%" class="indextable genindextable"><tr>
+  <td style="width: 33%" valign="top"><dl>
+    <dt><a href="api/data_info.html#DataLoader.data_info.Data2D.zaxis">zaxis() (DataLoader.data_info.Data2D method)</a></dt>
+    <dd><dl>
+      <dt><a href="api/data_info.html#DataLoader.data_info.plottable_2D.zaxis">(DataLoader.data_info.plottable_2D method)</a></dt>
+  </dl></dd>
+</dl></td>
+</tr></table>
+
+
+
+          </div>
+        </div>
+      </div>
+      <div class="sphinxsidebar">
+        <div class="sphinxsidebarwrapper">
+
+   
+
+<div id="searchbox" style="display: none">
+  <h3>Quick search</h3>
+    <form class="search" action="search.html" method="get">
+      <input type="text" name="q" size="18" />
+      <input type="submit" value="Go" />
+      <input type="hidden" name="check_keywords" value="yes" />
+      <input type="hidden" name="area" value="default" />
+    </form>
+    <p class="searchtip" style="font-size: 90%">
+    Enter search terms or a module, class or function name.
+    </p>
+</div>
+<script type="text/javascript">$('#searchbox').show(0);</script>
+        </div>
+      </div>
+      <div class="clearer"></div>
+    </div>
+    <div class="related">
+      <h3>Navigation</h3>
+      <ul>
+        <li class="right" style="margin-right: 10px">
+          <a href="#" title="General Index"
+             >index</a></li>
+        <li class="right" >
+          <a href="py-modindex.html" title="Python Module Index"
+             >modules</a> |</li>
+        <li><a href="index.html">DataLoader v0.1.0 documentation</a> &raquo;</li> 
+      </ul>
+    </div>
+    <div class="footer">
+        &copy; Copyright 2010, sans group.
+      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.7.
+    </div>
+  </body>
+</html>