Index: guiframe/local_perspectives/plotting/AnnulusSlicer.py
===================================================================
--- guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 55a0dc1b7e461f8c7193c0e63098d24bbed33eca)
+++ guiframe/local_perspectives/plotting/AnnulusSlicer.py	(revision 21969a4ae106963fab3e4194116463ca9438ca0e)
@@ -160,7 +160,13 @@
         # If the data file does not tell us what the axes are, just assume...
         new_plot.xaxis("\\rm{\phi}", 'degrees')
-        new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+        if hasattr(data, "scale"):
+            if data.scale == 'linear':
+                new_plot.ytransform = 'y'
+                new_plot.yaxis("\\rm{Residuals} ", "/")
+        else:
+            new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+
         new_plot.group_id = "AnnulusPhi" + self.base.data2D.name
-        new_plot.id = "AnnulusPhi" + self.base.data2D.name
+        new_plot.id = None
         #new_plot.is_data= True
         new_plot.xtransform = "x"
Index: guiframe/local_perspectives/plotting/SectorSlicer.py
===================================================================
--- guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 55a0dc1b7e461f8c7193c0e63098d24bbed33eca)
+++ guiframe/local_perspectives/plotting/SectorSlicer.py	(revision 21969a4ae106963fab3e4194116463ca9438ca0e)
@@ -167,5 +167,5 @@
         else:
             dxw = None
-        new_plot = Data1D(x=sector.x, y=sector.y, dy=sector.dy)
+        new_plot = Data1D(x=sector.x, y=sector.y, dy=sector.dy, dx=sector.dx)
         new_plot.dxl = dxl
         new_plot.dxw = dxw
@@ -175,10 +175,17 @@
         new_plot.interactive = True
         new_plot.detector = self.base.data2D.detector
-        # If the data file does not tell us what the axes are, just assume...
-        new_plot.xaxis("\\rm{Q}", 'A^{-1}')
-        new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+        ## If the data file does not tell us what the axes are, just assume...
+        new_plot.xaxis("\\rm{Q}", "A^{-1}")
+        if hasattr(data, "scale"):
+            if data.scale == 'linear':
+                new_plot.ytransform = 'y'
+                new_plot.yaxis("\\rm{Residuals} ", "/")
+        else:
+            new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
+       
         new_plot.group_id = "SectorQ" + self.base.data2D.name
-        new_plot.id = "SectorQ" + self.base.data2D.name
+        new_plot.id = None
         new_plot.is_data = True
+
         wx.PostEvent(self.base.parent, NewPlotEvent(plot=new_plot,
                                     title="SectorQ" + self.base.data2D.name))
Index: guiframe/local_perspectives/plotting/boxSlicer.py
===================================================================
--- guiframe/local_perspectives/plotting/boxSlicer.py	(revision 55a0dc1b7e461f8c7193c0e63098d24bbed33eca)
+++ guiframe/local_perspectives/plotting/boxSlicer.py	(revision 21969a4ae106963fab3e4194116463ca9438ca0e)
@@ -188,9 +188,14 @@
         new_plot.interactive = True
         new_plot.detector = self.base.data2D.detector
-        # If the data file does not tell us what the axes are, just assume...
-        new_plot.xaxis("\\rm{Q}", '\\AA^{-1}')
-        new_plot.yaxis("\\rm{Intensity} ","cm^{-1}")
+        ## If the data file does not tell us what the axes are, just assume...
+        new_plot.xaxis("\\rm{Q}", "A^{-1}")
+        if hasattr(self.base.data2D, "scale"):
+            if self.base.data2D.scale == 'linear':
+                new_plot.ytransform = 'y'
+                new_plot.yaxis("\\rm{Residuals} ", "/")
+        else:
+            new_plot.yaxis("\\rm{Intensity} ", "cm^{-1}")
         new_plot.group_id = str(self.averager.__name__) + self.base.data2D.name
-        new_plot.id = str(self.averager.__name__)
+        #new_plot.id = str(self.averager.__name__)
         #new_plot.is_data= True
         wx.PostEvent(self.base.parent, NewPlotEvent(plot=new_plot,
Index: guiframe/local_perspectives/plotting/masking.py
===================================================================
--- guiframe/local_perspectives/plotting/masking.py	(revision 55a0dc1b7e461f8c7193c0e63098d24bbed33eca)
+++ guiframe/local_perspectives/plotting/masking.py	(revision 21969a4ae106963fab3e4194116463ca9438ca0e)
@@ -9,5 +9,5 @@
 #following sentence:
 #
-#"This work benefited from DANSE software developed under NSF award DMR-0520547." 
+#This work benefited from DANSE software developed under NSF award DMR-0520547. 
 #
 #copyright 2008, University of Tennessee
@@ -19,8 +19,5 @@
 import sys
 import pylab
-from pylab import gca
-from pylab import gcf
 import math
-import re
 import copy
 import numpy
@@ -119,8 +116,6 @@
         sizer = wx.GridBagSizer(10, 10)
         #---------inputs----------------
-        #inputbox = wx.StaticBox(self, -1, "Draw Mask")
         shape_txt = wx.StaticText(self, -1, shape)  
         sizer.Add(shape_txt, (1, 1), flag=wx.TOP|wx.LEFT|wx.BOTTOM, border=5)
-        #innersector_x_txt = wx.StaticText(self, -1, 'Inner Sector')
         self.innersector_rb = wx.RadioButton(self, -1, "Double Wings")
         self.Bind(wx.EVT_RADIOBUTTON, self.onInnerSectorMask,
@@ -128,5 +123,4 @@
         sizer.Add(self.innersector_rb, (2, 1), 
                   flag=wx.RIGHT|wx.BOTTOM, border=5)
-        #innersector_x_txt = wx.StaticText(self, -1, 'Inner Sector')
         self.innercircle_rb = wx.RadioButton(self, -1, "Circular Disk")
         self.Bind(wx.EVT_RADIOBUTTON, self.onInnerRingMask,
@@ -139,5 +133,5 @@
                   id=self.innerbox_rb.GetId())
         sizer.Add(self.innerbox_rb, (4, 1), flag=wx.RIGHT|wx.BOTTOM, border=5)
-        #outersector_y_txt = wx.StaticText(self, -1, 'Outer Sector')
+
         self.outersector_rb = wx.RadioButton(self, -1, "Double Wing Window")
         self.Bind(wx.EVT_RADIOBUTTON, self.onOuterSectorMask, 
@@ -167,23 +161,23 @@
 
         #-----Buttons------------1
-        id = wx.NewId()
-        button_add = wx.Button(self, id, "Add")
+        id_button = wx.NewId()
+        button_add = wx.Button(self, id_button, "Add")
         button_add.SetToolTipString("Add the mask drawn.")
         button_add.Bind(wx.EVT_BUTTON, self.onAddMask, id=button_add.GetId()) 
         sizer.Add(button_add, (13, 7))
-        id = wx.NewId()
-        button_erase = wx.Button(self, id, "Erase")
+        id_button = wx.NewId()
+        button_erase = wx.Button(self, id_button, "Erase")
         button_erase.SetToolTipString("Erase the mask drawn.")
         button_erase.Bind(wx.EVT_BUTTON, self.onEraseMask,
                           id=button_erase.GetId()) 
         sizer.Add(button_erase, (13, 8))
-        id = wx.NewId()
-        button_reset = wx.Button(self, id, "Reset")
+        id_button = wx.NewId()
+        button_reset = wx.Button(self, id_button, "Reset")
         button_reset.SetToolTipString("Reset the mask.")
         button_reset.Bind(wx.EVT_BUTTON, self.onResetMask,
                           id=button_reset.GetId()) 
         sizer.Add(button_reset, (13, 9), flag=wx.RIGHT|wx.BOTTOM, border=15)
-        id = wx.NewId()
-        button_reset = wx.Button(self, id, "Clear")
+        id_button = wx.NewId()
+        button_reset = wx.Button(self, id_button, "Clear")
         button_reset.SetToolTipString("Clear all mask.")
         button_reset.Bind(wx.EVT_BUTTON, self.onClearMask,
@@ -270,5 +264,5 @@
             self.onClearSlicer(event)
         self.slicer_z += 1
-        self.slicer = CircularMask(self,self.subplot,
+        self.slicer = CircularMask(self, self.subplot,
                                    zorder=self.slicer_z, side=True)
         self.subplot.set_ylim(self.data.ymin, self.data.ymax)
@@ -309,5 +303,4 @@
         
         :param mask: mask data
-        
         """
         ## Redraw the current image
@@ -368,5 +361,4 @@
         
         :param slicer: slicer class to create
-        
         """
         ## Clear current slicer
@@ -480,4 +472,5 @@
     def freeze_axes(self):
         """
+        freeze axes
         """
         self.plotpanel.axes_frozen = True
@@ -485,4 +478,5 @@
     def thaw_axes(self):
         """
+        thaw axes
         """
         self.plotpanel.axes_frozen = False       
@@ -490,4 +484,5 @@
     def onMouseMotion(self, event):
         """
+        onMotion event
         """
         pass
@@ -495,4 +490,5 @@
     def onWheel(self, event):
         """
+        on wheel event
         """
         pass  
@@ -529,4 +525,5 @@
     def add_image(self, plot):
         """
+        Add Image
         """
         self.plots[plot.name] = plot
@@ -554,11 +551,8 @@
         # Slicer plot popup menu
         slicerpop = wx.Menu()
-        #id = wx.NewId()
-        #slicerpop.Append(id,'&Save image', 'Save image as PNG')
-        #wx.EVT_MENU(self, id, self.onSaveImage)
-        
-        id = wx.NewId()
-        slicerpop.Append(id, '&Toggle Linear/Log scale')
-        wx.EVT_MENU(self, id, self._onToggleScale)
+        
+        id_cm = wx.NewId()
+        slicerpop.Append(id_cm, '&Toggle Linear/Log scale')
+        wx.EVT_MENU(self, id_cm, self._onToggleScale)
                
         pos = event.GetPosition()
Index: guiframe/utils.py
===================================================================
--- guiframe/utils.py	(revision f444b20f1e24695fba634d38bf4839ddd05e95a6)
+++ guiframe/utils.py	(revision 21969a4ae106963fab3e4194116463ca9438ca0e)
@@ -26,5 +26,5 @@
         return output.lstrip().rstrip()
     if high:
-        output = "%-6.4g" % value
+        output = "%-7.5g" % value
     else:
         output = "%-5.3g" % value