Index: sansview/perspectives/fitting/fitting.py
===================================================================
--- sansview/perspectives/fitting/fitting.py	(revision d902cf02e3749fa098e63f091b8553ee83f94193)
+++ sansview/perspectives/fitting/fitting.py	(revision 27976fd0c59f7dcc5a00c2761e38479beef37bc2)
@@ -125,14 +125,9 @@
         self.fit_panel.set_model_list(self.menu_mng.get_model_list())
         owner.Bind(fitpage.EVT_MODEL_BOX,self._on_model_panel)
-        
-        #self.menu3= wx.Menu()
-        #id4 = wx.NewId()
-        
+      
         #create  menubar items
         return [(id, self.menu1, "Fitting"),
                 (id2, menu2, "Model")]
-        #return [(id, self.menu1, "Fitting"),
-        #        (id4,self.menu3,"Averagers"),
-        #        (id2, menu2, "Model")]
+       
     
     def on_add_sim_page(self, event):
@@ -448,9 +443,7 @@
                     current_pg= page
             except:
-                raise
-                return
-                #msg= "%s error: %s" % (engineType,sys.exc_value)
-                #wx.PostEvent(self.parent, StatusEvent(status= msg ))
-                #return 
+                msg= "%s error: %s" % (engineType,sys.exc_value)
+                wx.PostEvent(self.parent, StatusEvent(status= msg ))
+                return 
         #Do the simultaneous fit
         try:
@@ -483,8 +476,7 @@
             
         except:
-            raise
-            #msg= "%s error: %s" % (engineType,sys.exc_value)
-            #wx.PostEvent(self.parent, StatusEvent(status= msg ,type="stop"))
-            #return 
+            msg= "%s error: %s" % (engineType,sys.exc_value)
+            wx.PostEvent(self.parent, StatusEvent(status= msg ,type="stop"))
+            return 
               
               
@@ -570,9 +562,7 @@
             value.clear_model_param()
         except:
-            raise
+            msg= title +" error: %s" % sys.exc_value
+            wx.PostEvent(self.parent, StatusEvent(status= msg, type="stop"))
             return
-            #msg= title +" error: %s" % sys.exc_value
-            #wx.PostEvent(self.parent, StatusEvent(status= msg, type="stop"))
-            #return
        
     def _onSelect(self,event):
@@ -658,8 +648,9 @@
                         wx.PostEvent(self.parent, StatusEvent(status="Page was already Created"))
                 except:
-                    raise
-                    #wx.PostEvent(self.parent, StatusEvent(status="Creating Fit page: %s"\
-                    #%sys.exc_value))
-                    #return
+                    wx.PostEvent(self.parent, StatusEvent(status="Creating Fit page: %s"\
+                    %sys.exc_value))
+                    return
+                
+                
     def _updateFit(self):
         """
@@ -712,8 +703,7 @@
             wx.PostEvent(self.parent, StatusEvent(status=" " , type="stop")) 
         except:
-            raise
-            #msg= "Single Fit completed but Following error occurred:%s"% sys.exc_value
-            #wx.PostEvent(self.parent, StatusEvent(status=msg,type="stop"))
-            #return
+            msg= "Single Fit completed but Following error occurred:%s"% sys.exc_value
+            wx.PostEvent(self.parent, StatusEvent(status=msg,type="stop"))
+            return
        
        
Index: sansview/perspectives/fitting/modelpage.py
===================================================================
--- sansview/perspectives/fitting/modelpage.py	(revision 6fdfc8fab90b8745b06ee22c6b8c7121258d54e1)
+++ sansview/perspectives/fitting/modelpage.py	(revision 27976fd0c59f7dcc5a00c2761e38479beef37bc2)
@@ -66,8 +66,9 @@
             
         else:
-            description=""
+            description="Model contains no description"
             if self.model!=None:
                 description = self.model.description
-                
+            if description.lstrip().rstrip() =="": 
+                description="Model contains no description"
             self.description = wx.StaticText( self,-1,str(description) )
             self.sizer_description.Add( self.description, 1, wx.EXPAND | wx.ALL, 10 )
@@ -403,4 +404,9 @@
         if frame.rhelp.HasAnchor(name):
             frame.rhelp.ScrollToAnchor(name)
+        else:
+           msg= "Model does not contains an available description "
+           msg +="Please.Search in the Help window"
+           wx.PostEvent(self.parent.parent, StatusEvent(status = msg ))
+                     
             
             